package com.prank.master.ui;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.SystemClock;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;

import com.prank.master.R;
import com.prank.master.databinding.ActivityRecordAudioBinding;
import com.prank.master.utils.AudioRecorder;
import com.prank.master.utils.CommonUtils;

public class RecordAudioActivity extends AppCompatActivity {
    ActivityRecordAudioBinding  binding;
    private long startTime;
    private long elapsedTime;
    private Handler handler = new Handler();
    private Runnable runnable;
    private boolean isCreate = false;

    private AudioRecorder audioRecorder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = ActivityRecordAudioBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
        CommonUtils.setStatusBarTextColor(this, true);
        audioRecorder = new AudioRecorder(this);

        binding.audioTime.setText(R.string.time_init);

        initEvent();
    }

    private void initEvent() {
        binding.back.setOnClickListener(v -> finish());
        binding.imMic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                binding.imMic.setSelected(!binding.imMic.isSelected());
                createSound();
            }
        });
    }

    private void createSound() {
        if (!isCreate) {
            audioRecorder.startRecording();
            isCreate = true;
            runnable = new Runnable() {
                @SuppressLint("DefaultLocale")
                @Override
                public void run() {
                    long currentTime = SystemClock.elapsedRealtime();
                    elapsedTime = currentTime - startTime;
                    int milliseconds = (int) (elapsedTime % 1000) / 10;
                    int seconds = (int) (elapsedTime / 1000) % 60;
                    int minutes = (int) (elapsedTime / (1000 * 60)) % 60;
                    binding.audioTime.setText(String.format("%02d : %02d : %02d", minutes, seconds, milliseconds));
                    handler.postDelayed(this, 10);
                }
            };
            startTime = SystemClock.elapsedRealtime();
            handler.post(runnable);
        } else {
            audioRecorder.stopRecording();

            handler.removeCallbacks(runnable);
            Intent intent = new Intent(RecordAudioActivity.this, SaveAudioActivity.class);
            intent.putExtra(SaveAudioActivity.KEY_Time, elapsedTime);
            intent.putExtra(SaveAudioActivity.KEY_Path, audioRecorder.getTempFileName());
            intent.putExtra(SaveAudioActivity.KEY_import, 1);
            startActivity(intent);
            finish();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        handler.removeCallbacks(runnable);
    }
}